VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Ejemplo Conexin API REST"
   ClientHeight    =   6060
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   9600
   LinkTopic       =   "Form1"
   ScaleHeight     =   6060
   ScaleWidth      =   9600
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command2 
      Caption         =   "Cancelar por CSD"
      Height          =   375
      Left            =   6960
      TabIndex        =   2
      Top             =   120
      Width           =   2175
   End
   Begin VB.TextBox Text1 
      Height          =   5175
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Text            =   "Form1.frx":0000
      Top             =   720
      Width           =   9135
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Timbrar XML"
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Top             =   120
      Width           =   2175
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private WithEvents winH As WinHttp.WinHttpRequest
Attribute winH.VB_VarHelpID = -1

Private Sub Form_Load()
    'SE CREA EL OBJETO DE CONEXIN HTTP
    '   NOTA: debe estar agregada la Referencia "Microsoft WinHTTP.Services"
    Set winH = New WinHttp.WinHttpRequest
End Sub

Private Sub Command1_Click()
    'SE ABRE LA CONEXIN HTTP AL API REST
    winH.Open "post", "http://localhost/multipac/api/rest/servicio/timbrar"
    'SE DEFINEN LOS HEADERS NECESARIOS DEL REQUEST
    winH.SetRequestHeader "Content-Type", "application/x-www-form-urlencoded"
    
    'SE CREA LA VARIABLE QUE CONTENDR EL CUERPO DE LA SOLICITUD
    Dim PostData As String
    
    'SE ESPECIFICA EL APIKEY DE LA CUENTA DE TIMBRADO
    Dim credencial As String
    credencial = "93edc4af66b84c938f66a56ca0596205"
    
    'SE CARGA EL ARCHIVO XML EN ARREGLO DE BYTES
    Dim xml() As Byte
    xml = GetFileData("entrada\ejemplo_cfdi40.xml")
    
    'SE CONVIERTE ARREGLO DE BYTES A STRING
    Dim cfdi As String
    cfdi = StrConv(xml, vbUnicode)
    
    'SE ESPECIFICAN LOS PARMETROS DEL SERVICIO: apikey y xmlCFDI
    PostData = "apikey=" + credencial + "&" + "xmlCFDI=" + URLencode(cfdi)
    
    'SE ESPECIFICA EL TAMAO DE LOS DATOS EN EL HEADER
    winH.SetRequestHeader "Content-Length", Len(PostData)
    
    'SE REALIZA EL REQUEST
    winH.Send PostData
    
    'PARSEO DEL JSON DE DATOS DE RESPUESTA
    Dim p As Object
    Set p = JSON.parse(winH.ResponseText)
    
    'SE MUESTRA LA RESPUESTA (Todos los atributos de la respuesta son String)
    Text1.Text = "CODIGO: " & p.Item("code") & vbCrLf _
     & vbCrLf & "MENSAJE: " & p.Item("message") & vbCrLf _
     & vbCrLf & "CFDI: " & p.Item("data") & vbCrLf
     
    'ESTE ES EL JSON DE RESPUESTA (DESCOMENTA LA SIGUIENTE LNEA PARA VER LA RESPUESTA ORIGINAL)
    'Text1.Text = winH.responseText
End Sub

'FUNCION QUE CONVIERTE UN ARCHIVO EN UN ARREGLO DE BYTES
Public Function GetFileData(ByVal Filename As String) As Byte()

    Dim f As Integer

    f = FreeFile

    Open Filename For Binary Access Read As #f
    ReDim GetFileData(0 To LOF(f) - 1)
    Get #f, , GetFileData
    Close #f

End Function

Private Sub Command2_Click()

    'SE ESPECIFICA EL APIKEY DE LA CUENTA DE TIMBRADO
    Dim credencial As String
    credencial = "93edc4af66b84c938f66a56ca0596205"
    
    'SE CARGA EL ARCHIVO DE LA LLAVE PRIVADA
    Dim key() As Byte
    key = GetFileData("entrada\CSD_EKU9003173C9.key")
    'SE CONVIERTE EL .key A STRING EN BASE64
    Dim keyCSD As String
    keyCSD = GetBase64String(key)
    
    'SE CARGA EL ARCHIVO DE LA LLAVE PUBLICA
    Dim cer() As Byte
    cer = GetFileData("entrada\CSD_EKU9003173C9.cer")
    'SE CONVIERTE EL .cer A STRING EN BASE64
    Dim cerCSD As String
    cerCSD = GetBase64String(cer)
    
    'SE ESPECIFICA LA CONTRASEA DEL CSD
    Dim passCSD As String
    passCSD = "12345678a"
    
    'SE ESPECIFICA EL UUID DEL CFDI A CANCELAR
    Dim uuid As String
    uuid = "38bb54b2-22c1-44a1-a57a-ace47e08f7e2"
    
    'SE ESPECIFICA EL RFC DEL EMISOR
    Dim rfcEmisor As String
    rfcEmisor = "EKU9003173C9"
    
    'SE ESPECIFICA EL RFC DEL RECEPTOR
    Dim rfcReceptor As String
    rfcReceptor = "URE180429TM6"
    
    'SE ESPECIFICA EL TOTAL DEL CFDI
    Dim total As String
    total = "1.12"
    
    'SE ESPECIFICA EL MOTIVO DE CANCELACIN: 01, 02, 03 o 04
    Dim motivo As String
    motivo = "02"
    
    'SE ESPECIFICA EL FOLIO DE SUSTITUCIN, SI NO EXISTE SE DEJA VACO
    Dim folioSustitucion As String
    folioSustitucion = ""
    
    
    'SE ABRE LA CONEXIN HTTP AL API REST
    winH.Open "post", "http://localhost/multipac/api/rest/servicio/cancelar2"
    'SE DEFINEN LOS HEADERS NECESARIOS DEL REQUEST
    winH.SetRequestHeader "Content-Type", "application/x-www-form-urlencoded"
    
    'SE CREA LA VARIABLE QUE CONTENDR EL CUERPO DE LA SOLICITUD
    Dim PostData As String
    
    'SE ESPECIFICAN LOS PARMETROS DEL SERVICIO:
    PostData = "apikey=" + credencial _
    + "&keyCSD=" + URLencode(keyCSD) _
    + "&cerCSD=" + URLencode(cerCSD) _
    + "&passCSD=" + URLencode(passCSD) _
    + "&uuid=" + uuid _
    + "&rfcEmisor=" + URLencode(rfcEmisor) _
    + "&rfcReceptor=" + URLencode(rfcReceptor) _
    + "&total=" + total _
    + "&motivo=" + motivo _
    + "&folioSustitucion=" + folioSustitucion
       
    'SE ESPECIFICA EL TAMAO DE LOS DATOS EN EL HEADER
    winH.SetRequestHeader "Content-Length", Len(PostData)
    
    'SE REALIZA EL REQUEST
    winH.Send PostData
    
    'PARSEO DEL JSON DE DATOS DE RESPUESTA
    Dim p As Object
    Set p = JSON.parse(winH.ResponseText)
    'PARSEO DEL JSON QUE CONTIENE EL ACUSE
    Dim pp As Object
    Set pp = JSON.parse(JSON.toString(p.Item("data")))
    
    'SE MUESTRA LA RESPUESTA (Todos los atributos de la respuesta son String)
    Text1.Text = "CODIGO: " & p.Item("code") & vbCrLf _
     & vbCrLf & "MENSAJE: " & p.Item("message") & vbCrLf _
     & vbCrLf & "ACUSE: " & pp.Item("acuse") & vbCrLf
     
    'ESTE ES EL JSON DE RESPUESTA (DESCOMENTA LA SIGUIENTE LNEA PARA VER LA RESPUESTA ORIGINAL)
    'Text1.Text = Text1.Text + vbCrLf + winH.responseText
End Sub

'FUNCION QUE CORRIGE LA CODIFICACIN DE DATOS QUE VAYAN A SER ENVIADOS A TRAVS DE UNA URL
Public Function URLencode(ByRef Text As String) As String
    Const Hex = "0123456789ABCDEF"
    Dim lngA As Long, lngChar As Long
    URLencode = Text
    For lngA = LenB(URLencode) - 1 To 1 Step -2
        lngChar = Asc(MidB$(URLencode, lngA, 2))
        Select Case lngChar
            Case 48 To 57, 65 To 90, 97 To 122
            Case 32
                MidB$(URLencode, lngA, 2) = "+"
            Case Else
                URLencode = LeftB$(URLencode, lngA - 1) & "%" & Mid$(Hex, (lngChar And &HF0) \ &H10 + 1, 1) & Mid$(Hex, (lngChar And &HF&) + 1, 1) & MidB$(URLencode, lngA + 2)
        End Select
    Next lngA
End Function

'FUNCION QUE CONVIERTE EL ARREGLO DE BYTES A BASE 64 PARA USARLO COMO STRING
Public Function GetBase64String(ByRef data() As Byte) As String

    Dim doc As DOMDocument
    Dim root As IXMLDOMElement

    Set doc = New DOMDocument
    Set root = doc.createElement("encode")
    root.dataType = "bin.base64"
    root.nodeTypedValue = data

    GetBase64String = root.Text

End Function
